﻿
using System;
using Wisej.Web;

namespace Wisej.ListViewSorting
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			for (int i = 0; i < 10; i++)
			{
				var item = new ListViewItem(DateTime.Now.AddDays(i).ToShortDateString());
				item.SubItems.Add((i * 2).ToString());
				item.SubItems.Add("Item " + i);

				this.listView1.Items.Add(item);
			}

			// store the data types for each column.
			// the items in the column can only contain text, but we
			// can save the type for later parsing and sorting.
			this.listView1.Columns[0].UserData.DataType = typeof(DateTime);
			this.listView1.Columns[1].UserData.DataType = typeof(Int32);
			this.listView1.Columns[2].UserData.DataType = typeof(String);
		}

		//
		// Another way to sort. This is fully custom.
		//
		private void listView1_ColumnClick(object sender, ColumnClickEventArgs e)
		{
			ListView listView = (ListView)sender;
			ColumnHeader column = listView.Columns[e.Column];
			ColumnHeader sortedColumn = listView.UserData.SortedColumn;

			// remove the sort glyph from the previously sorted column.
			if (sortedColumn != null && sortedColumn != column)
			{
				sortedColumn.SortGlyph = SortOrder.None;
			}

			// flip the sort glyph displayed in the header.
			if (column.SortGlyph == SortOrder.Ascending)
				column.SortGlyph = SortOrder.Descending;
			else
				column.SortGlyph = SortOrder.Ascending;

			// update the currently sorted column.
			listView.UserData.SortedColumn = column;

			// sort the column.
			Type dataType = column.UserData.DataType;
			var direction = column.SortGlyph == SortOrder.Ascending ? 1 : -1;
			if (dataType == typeof(DateTime))
			{
				listView.Sort((x, y) =>
				{
					return direction * DateTime.Compare(DateTime.Parse(x.SubItems[column.Index].Text), DateTime.Parse(y.SubItems[column.Index].Text));
				});
			}
			else if (dataType == typeof(Int32))
			{
				listView.Sort((x, y) =>
				{
					return direction * Int32.Parse(x.SubItems[column.Index].Text) - Int32.Parse(y.SubItems[column.Index].Text);
				});
			}
			else
			{
				listView.Sort((x, y) =>
				{
					return direction * String.Compare(x.SubItems[column.Index].Text, y.SubItems[column.Index].Text);
				});

			}
		}
	}
}
